<template>
    <div class="order-request-execution">
      <ObForm
        ref="form"
        :form-model="formModel"
        :form-data="formData"
        ok-text="Перезапустить"
        :is-loading="isLoading"
        data-qa="autoSearchRestartModal"
        :is-submit-disabled="isSubmitDisabled"
        @submit="onSubmitHandler"
      >
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          :upload-method="uploadMethod"
          @process-start="startUploadFiles"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObUploader from 'common-components/src/obComponents/obUploader'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'

export default {
  name: 'autoSearchRestartModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObUploader
  },
  props: {
    order: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    formModel () {
      return {
        fileUuid: {
          value: ''
        }
      }
    },
    uploadMethod () {
      return api.files.postFile
    },
    isSubmitDisabled () {
      return this.formData.fileUuid === 'loading'
    }
  },
  watch: {
    'formData.fileUuid' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    startUploadFiles () {
      this.formData.fileUuid = 'loading'
    },
    async onUploadHandler (data) {
      data = data[0]

      if (!data) {
        this.formData.fileUuid = null
        return
      }

      this.formData.fileUuid = data.uuid
    },
    async onSubmitHandler (data) {
      try {
        this.isLoading = true
        await api.orderProcess.autosearchRestart({ uuid: this.order.uuid, data })
        setTimeout(() => {
          this.isLoading = false
          this.$refs.form.parentModal.close()
          this.$notification({
            type: 'system_notification_success',
            message: 'Автопоиск перезапущен'
          })
        }, 1000)
      } catch (e) {
        this.isLoading = false
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка перезапуска автопоиска'
        })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
  }
</style>
